import type { JSX } from '../../stencil-public-runtime';
import type { LabelPropType, TableCallbacksPropType, TableDataFootPropType, TableDataPropType, TableHeaderCellsPropType, TableSelectionPropType, TableStatelessAPI, TableStatelessStates } from '../../schema';
export declare class KolTableStateless implements TableStatelessAPI {
    private readonly host?;
    state: TableStatelessStates;
    private tableDivElement?;
    private tableDivElementResizeObserver?;
    private horizontal;
    private cellsToRenderTimeouts;
    private dataToKeyMap;
    private checkboxRefs;
    private tableDivElementHasScrollbar;
    _data: TableDataPropType;
    _dataFoot?: TableDataFootPropType;
    _headerCells: TableHeaderCellsPropType;
    _label: string;
    _minWidth?: string;
    _on?: TableCallbacksPropType;
    _selection?: TableSelectionPropType;
    validateData(value?: TableDataPropType): void;
    validateDataFoot(value?: TableDataFootPropType): void;
    validateHeaderCells(value?: TableHeaderCellsPropType): void;
    validateLabel(value?: LabelPropType): void;
    validateMinWidth(value?: string): void;
    validateOn(value?: TableCallbacksPropType): void;
    validateSelection(value?: TableSelectionPropType): void;
    handleKeyDown(event: KeyboardEvent): void;
    componentDidRender(): void;
    componentDidLoad(): void;
    disconnectedCallback(): void;
    private checkDivElementScrollbar;
    private updateDataToKeyMap;
    private getDataKey;
    private cellRender;
    private getNumberOfCols;
    private getNumberOfRows;
    private filterHeaderKeys;
    private getPrimaryHeader;
    private createDataField;
    componentWillLoad(): void;
    private renderSelectionCell;
    private readonly renderTableRow;
    private readonly renderTableCell;
    private renderHeadingSelectionCell;
    private renderHeadingCell;
    private renderSpacer;
    private renderFoot;
    render(): JSX.Element;
}
