import type { Generic } from 'adopted-style-sheets';
import type { WatchStringOptions } from '../utils';
export declare const headingLevelOptions: readonly [0, 1, 2, 3, 4, 5, 6];
export type HeadingLevel = (typeof headingLevelOptions)[number];
export declare function hasEnoughReadableChars(str: string, min?: number): boolean;
export declare function containsOnlyNumbers(str: string): boolean;
export type LabelPropType = string;
export type LabelWithExpertSlotPropType = LabelPropType | '';
export type PropLabel = {
    label: LabelPropType;
};
export type PropLabelWithExpertSlot = {
    label: LabelWithExpertSlotPropType;
};
export type LabelProp = Generic.Element.Members<PropLabel, unknown>;
export declare const validateLabel: (component: Generic.Element.Component, value?: LabelPropType, options?: WatchStringOptions) => void;
export declare const validateLabelWithExpertSlot: (component: Generic.Element.Component, value?: LabelPropType, options?: WatchStringOptions) => void;
