/*!
 * KoliBri - The accessible HTML-Standard
 */
import{proxyCustomElement,HTMLElement,h,Host}from"@stencil/core/internal/client";import{o as onLocationChange}from"./ariaCurrentService.js";import{p as preventDefaultAndStopPropagation}from"./events.js";import{n as nonce}from"./dev.utils2.js";import{g as KolSpanWcTag,e as KolIconTag,a as KolTooltipWcTag}from"./component-names.js";import{t as translate}from"./i18n2.js";import{v as validateAccessKey,a as validateAccessAndShortKey,b as validateShortKey,c as validateTabIndex}from"./access-and-short-key.js";import{w as watchValidator,e as watchString,l as setEventTarget,q as devHint}from"./prop.validators.js";import{v as validateHref}from"./href.js";import{s as showExpertSlot}from"./reuse.js";import{v as validateAriaDescription,a as validateAriaExpanded,b as validateAlternativeButtonLinkRole}from"./aria-expanded.js";import{v as validateDisabled}from"./disabled.js";import{v as validateHideLabel}from"./hide-label.js";import{v as validateIcons}from"./icons.js";import{a as validateLabelWithExpertSlot}from"./label.js";import{v as validateTooltipAlign}from"./tooltip-align.js";const ariaCurrentValuePropTypeOptions=["date","location","page","step","time","true","false"],validateAriaCurrentValue=(a,e)=>{watchValidator(a,"_ariaCurrentValue",(a=>"string"==typeof a&&ariaCurrentValuePropTypeOptions.includes(a)),new Set([`AriaCurrentValue {${ariaCurrentValuePropTypeOptions.join(", ")}`]),e,{defaultValue:"page"})},validateAriaOwns=(a,e)=>{watchString(a,"_ariaOwns",e,{defaultValue:void 0})},validateDownload=(a,e)=>{watchString(a,"_download",e)},validateLinkCallbacks=(a,e)=>{"object"==typeof e&&"function"==typeof(null==e?void 0:e.onClick)&&(a.state=Object.assign(Object.assign({},a.state),{_on:e}))},validateLinkTarget=(a,e)=>{watchString(a,"_target",e)},KolLinkWc$1=proxyCustomElement(class extends HTMLElement{constructor(){super(),this.__registerHost(),this.internalDescriptionById=nonce(),this.catchRef=a=>{this.anchorRef=a},this.onClick=a=>{var e,t;!0===this.state._disabled?preventDefaultAndStopPropagation(a):"function"==typeof(null===(e=this.state._on)||void 0===e?void 0:e.onClick)&&(a.preventDefault(),a.stopPropagation(),setEventTarget(a,this.anchorRef),null===(t=this.state._on)||void 0===t||t.onClick(a,this.state._href))},this.getRenderValues=()=>{const a="string"==typeof this.state._target&&"_self"!==this.state._target,e={href:"string"==typeof this.state._href&&this.state._href.length>0?this.state._href:"javascript:void(0);",target:"string"==typeof this.state._target&&this.state._target.length>0?this.state._target:void 0,rel:a?"noopener":void 0,download:"string"==typeof this.state._download?this.state._download:void 0};return!0!==this.state._hideLabel||this.state._label||devHint("[KolLink] An aria-label must be set when _hide-label is set."),{isExternal:a,tagAttrs:e}},this._accessKey=void 0,this._ariaCurrentValue=void 0,this._ariaDescription=void 0,this._ariaExpanded=void 0,this._ariaOwns=void 0,this._disabled=!1,this._download=void 0,this._hideLabel=!1,this._href=void 0,this._icons=void 0,this._label=void 0,this._on=void 0,this._role=void 0,this._shortKey=void 0,this._tabIndex=void 0,this._target=void 0,this._tooltipAlign="right",this.state={_ariaCurrentValue:"page",_href:"",_icons:{}}}async kolFocus(){var a;null===(a=this.anchorRef)||void 0===a||a.focus()}render(){var a,e;const{isExternal:t,tagAttrs:i}=this.getRenderValues(),s=showExpertSlot(this.state._label),l=Boolean(null===(e=null===(a=this.state._ariaDescription)||void 0===a?void 0:a.trim())||void 0===e?void 0:e.length);return h(Host,{key:"022a8e8b4e878c01769d9bc2055489e8339e61e8",class:"kol-link-wc"},h("a",Object.assign({key:"be75d4ced0efa0e3d9628ddf2258153d2b05276a",ref:this.catchRef},i,{accessKey:this.state._accessKey,"aria-current":this.state._ariaCurrent,"aria-describedby":l?this.internalDescriptionById:void 0,"aria-disabled":this.state._disabled?"true":void 0,"aria-expanded":"boolean"==typeof this.state._ariaExpanded?String(this.state._ariaExpanded):void 0,"aria-owns":this.state._ariaOwns,"aria-label":this.state._hideLabel&&"string"==typeof this.state._label?`${this.state._label}${t?` (${translate("kol-open-link-in-tab")})`:""}`:void 0,class:{disabled:!0===this.state._disabled,"external-link":t,"hide-label":!0===this.state._hideLabel}},this.state._on,{onClick:this.onClick,onKeyPress:this.onClick,role:this.state._role,tabIndex:this.state._disabled?-1:this.state._tabIndex}),h(KolSpanWcTag,{key:"a660f84c110c0e4ff769ba8c2063413f0675e086",_badgeText:this.state._accessKey||this.state._shortKey,_icons:this.state._icons,_hideLabel:this.state._hideLabel,_label:s?"":this.state._label||this.state._href},h("slot",{key:"324e3e6fc7dc8ad85ae6698fe4aae4e52bb89dd2",name:"expert",slot:"expert"})),t&&h(KolIconTag,{key:"e37ab8b96fd28666c16a089aaf80307e9a52829e",class:"external-link-icon",_label:this.state._hideLabel?"":translate("kol-open-link-in-tab"),_icons:"codicon codicon-link-external","aria-hidden":this.state._hideLabel})),h(KolTooltipWcTag,{key:"393ee80cec558f6c6c8500e6e32dbc7e50f12297","aria-hidden":"true",hidden:s||!this.state._hideLabel,_badgeText:this.state._accessKey||this.state._shortKey,_align:this.state._tooltipAlign,_label:this.state._label||this.state._href}),l&&h("span",{key:"67689414a8c93be7080f1d435b6521891f4a4f84",class:"visually-hidden",id:this.internalDescriptionById},this.state._ariaDescription))}validateAccessKey(a){validateAccessKey(this,a),validateAccessAndShortKey(a,this._shortKey)}validateAriaCurrentValue(a){validateAriaCurrentValue(this,a)}validateAriaDescription(a){validateAriaDescription(this,a)}validateAriaExpanded(a){validateAriaExpanded(this,a)}validateAriaOwns(a){validateAriaOwns(this,a)}validateDisabled(a){validateDisabled(this,a)}validateDownload(a){validateDownload(this,a)}validateHideLabel(a){validateHideLabel(this,a)}validateHref(a){validateHref(this,a,{required:!0})}validateIcons(a){validateIcons(this,a)}validateLabel(a){validateLabelWithExpertSlot(this,a)}validateOn(a){validateLinkCallbacks(this,a)}validateRole(a){validateAlternativeButtonLinkRole(this,a)}validateShortKey(a){validateShortKey(this,a),validateAccessAndShortKey(this._accessKey,a)}validateTabIndex(a){validateTabIndex(this,a)}validateTarget(a){validateLinkTarget(this,a)}validateTooltipAlign(a){validateTooltipAlign(this,a)}componentWillLoad(){this.validateAccessKey(this._accessKey),this.validateAriaCurrentValue(this._ariaCurrentValue),this.validateAriaDescription(this._ariaDescription),this.validateAriaExpanded(this._ariaExpanded),this.validateAriaOwns(this._ariaOwns),this.validateDisabled(this._disabled),this.validateDownload(this._download),this.validateHideLabel(this._hideLabel),this.validateHref(this._href),this.validateIcons(this._icons),this.validateLabel(this._label),this.validateOn(this._on),this.validateRole(this._role),this.validateShortKey(this._shortKey),this.validateTabIndex(this._tabIndex),this.validateTarget(this._target),this.validateTooltipAlign(this._tooltipAlign),this.unsubscribeOnLocationChange=onLocationChange((a=>{this.state._ariaCurrent=a===this.state._href?this.state._ariaCurrentValue:void 0})),validateAccessAndShortKey(this._accessKey,this._shortKey)}disconnectedCallback(){this.unsubscribeOnLocationChange&&this.unsubscribeOnLocationChange()}static get watchers(){return{_accessKey:["validateAccessKey"],_ariaCurrentValue:["validateAriaCurrentValue"],_ariaDescription:["validateAriaDescription"],_ariaExpanded:["validateAriaExpanded"],_ariaOwns:["validateAriaOwns"],_disabled:["validateDisabled"],_download:["validateDownload"],_hideLabel:["validateHideLabel"],_href:["validateHref"],_icons:["validateIcons"],_label:["validateLabel"],_on:["validateOn"],_role:["validateRole"],_shortKey:["validateShortKey"],_tabIndex:["validateTabIndex"],_target:["validateTarget"],_tooltipAlign:["validateTooltipAlign"]}}},[4,"kol-link-wc",{_accessKey:[1,"_access-key"],_ariaCurrentValue:[1,"_aria-current-value"],_ariaDescription:[1,"_aria-description"],_ariaExpanded:[4,"_aria-expanded"],_ariaOwns:[1,"_aria-owns"],_disabled:[4],_download:[1],_hideLabel:[4,"_hide-label"],_href:[1],_icons:[1],_label:[1],_on:[16],_role:[1],_shortKey:[1,"_short-key"],_tabIndex:[2,"_tab-index"],_target:[1],_tooltipAlign:[1,"_tooltip-align"],state:[32],kolFocus:[64]},void 0,{_accessKey:["validateAccessKey"],_ariaCurrentValue:["validateAriaCurrentValue"],_ariaDescription:["validateAriaDescription"],_ariaExpanded:["validateAriaExpanded"],_ariaOwns:["validateAriaOwns"],_disabled:["validateDisabled"],_download:["validateDownload"],_hideLabel:["validateHideLabel"],_href:["validateHref"],_icons:["validateIcons"],_label:["validateLabel"],_on:["validateOn"],_role:["validateRole"],_shortKey:["validateShortKey"],_tabIndex:["validateTabIndex"],_target:["validateTarget"],_tooltipAlign:["validateTooltipAlign"]}]);function defineCustomElement$1(){if("undefined"==typeof customElements)return;["kol-link-wc"].forEach((a=>{if("kol-link-wc"===a)customElements.get(a)||customElements.define(a,KolLinkWc$1)}))}const KolLinkWc=KolLinkWc$1,defineCustomElement=defineCustomElement$1;export{KolLinkWc,defineCustomElement};